'Option Strict Off
'Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.Data.OleDb

Module Module1


	'=========================================================

    Const C_VARS_PER_SIDE_MAX As Short = 50
    Public blnIsIfStatement As Boolean
    Public blnIsTernaryIfStatement As Boolean
    Public blnIsAssignmentStatement As Boolean
    Public blnIsMethodDefinition As Boolean
    Public blnIsWhileStatement As Boolean
    Public blnIsCaseStatement As Boolean
    Public blnHasIteratorSymbols As Boolean
    Public blnMethodsHaveBeenSelected As Boolean
    Public blnBreakpointsHaveBeenSelected As Boolean
    Public blnNoDebugMethod As Boolean
    Public blnBlockOfComments As Boolean

    Public intMethodsSelectedCount As Short
    Public intBreakpointsCount As Short
    Public intOperatorPosition As Short
    Public intOperatorLength As Short
    Public intPosition As Short
    Public intPosition2 As Short
    Public intOutFileNumber As Short
    Public intOperatorCount As Short
    Public istop As Short
    Public intEndOfElement As Short
    Public intLocVarStartsAtChar As Short
    Public intErrCode As Short
    Public intTernary1 As Short
    Public intTernary2 As Short
    Public intTernary3 As Short

    Public lngSourcefileLinecount As Integer
    Public lngSourcefileLinecountMyPrint As Integer
    Public lngLineCountLimit As Integer
    Public lngDebugLinesInSourceFile As Integer

    Public strQ As String
    Public strQQ As String
    Public strC As String
    Public strTypeToSelect As String
    Public strNextLine As String
    Public strUniversalPath As String
    Public strFilename As String
    Public strFilenameOut As String
    Public strAppTitle As String
    Public strFilenameB4 As String
    Public strClassDec As String
    Public strLeft As String
    Public strRight As String
    Public strPrintDebugMethod As String
    Public strHere As String
    Public strClassFound As String
    Public strMethodFound As String

    Public straryOriginalLines(100000) As String
    Public straryLines(100000) As String
    Public strarySelectedMethods(1000) As String
    Public straryBreakpoints(1000) As String
    Public straryOperators(100) As String
    Public straryLinesdbfrMyPrint(1000) As String
    ' VBto upgrade warning: strX As Object --> As String
    Public Function blnThisLineIsClassDeclaration(ByVal strX As String) As Boolean
        Dim strAA As String = ""

        If VB.Left(Trim(strX), 6)="class " Then
            blnThisLineIsClassDeclaration = True
            strAA = Mid(strX, 7)
            GetEndOfElement(strAA)
            strClassDec = VB.Left(strAA, intEndOfElement)
        Else
            blnThisLineIsClassDeclaration = False
        End If
    End Function
    Public Sub FindStatementType()
        Dim strX As String = ""

        blnIsWhileStatement = False
        blnIsCaseStatement = False
        blnHasIteratorSymbols = False
        blnIsMethodDefinition = False
        blnIsIfStatement = False
        blnIsTernaryIfStatement = False
        blnIsAssignmentStatement = False
        intOperatorPosition = 0
        intOperatorLength = 0
        strX = strRemoveQuotesFrom(strC, True)
        If intErrCode = 5 Then
            GoTo xit
        End If
        intTernary1 = InStr(strX, "?")
        If intTernary1>0 Then
            intTernary2 = InStr(strX, ":")
            If intTernary2>intTernary1+3 Then
                strX = Replace(strX, ":", "~", 1, 1)
                intTernary3 = InStr(strX, ":")
                If intTernary3>intTernary2+3 Then
                    blnIsTernaryIfStatement = True
                End If
            End If
        End If
        If VB.Left(Trim(strC), 2)="if" Then
            strX = Mid(strC, 3)
            If VB.Left(strX, 1)=" " Then
                blnIsIfStatement = True
            End If
            If VB.Left(Trim(strX), 1)="(" Then
                blnIsIfStatement = True
            End If
            If blnIsIfStatement Then
                intOperatorPosition = intFindOperator(strC)
                If intOperatorPosition=0 Then 'no operator if has not comparison operator
                    intOperatorPosition = Len(strC)+1 'for example, "if @reverser" as entire statement
                End If
                goto xit
            Else
                MsgBox("ERROR-IF STATEMENT LOOKS SUSPICIOUS IN " & vbCrLf & strC, MsgBoxStyle.Exclamation, strAppTitle)
            End If
            blnIsIfStatement = True
            intOperatorPosition = intFindOperator(strC)
            goto xit
        End If
        If VB.Left(Trim(strC), 5)="elsif" Then
            strX = Mid(strC, 6)
            If VB.Left(strX, 1)=" " Then
                blnIsIfStatement = True
            End If
            If VB.Left(Trim(strX), 1)="(" Then
                blnIsIfStatement = True
            End If
            If blnIsIfStatement Then
                intOperatorPosition = intFindOperator(strC)
                If intOperatorPosition=0 Then 'no operator if has not comparison operator
                    intOperatorPosition = Len(strC)
                End If
                goto xit
            Else
                MsgBox("ERROR-ELSIF STATEMENT LOOKS SUSPICIOUS IN " & vbCrLf & strC, MsgBoxStyle.Exclamation, strAppTitle)
            End If
            blnIsIfStatement = True
            intOperatorPosition = intFindOperator(strC)
            goto xit
        End If
        If VB.Left(Trim(strC), 6)="while " Then
            blnIsWhileStatement = True
            intOperatorPosition = intFindOperator(strC)
            goto xit
        End If
        If VB.Left(Trim(strC), 5)="case " Then
            blnIsCaseStatement = True
            goto xit
        End If
        intPosition = InStr(Trim(strC), "def ")
        If intPosition>1 Then
            intPosition2 = InStr(Trim(strC), "/")
            If intPosition2=intPosition-1 Then
                strClassFound = VB.Left(Trim(strC), intPosition2)
                strMethodFound = VB.Right(Trim(strC), intPosition+4)
                blnIsMethodDefinition = True
            End If
        End If
        If VB.Left(UCase(Trim(strNextLine)), 14)="#NODEBUGPLEASE" Then
            blnNoDebugMethod = True
            goto xit
        Else
            blnNoDebugMethod = False
        End If
        intPosition = InStr(strC, ".mth")
        intPosition = InStr(strC, "|")
        If intPosition>0 Then
            intPosition2 = InStr(intPosition+1, strC, "|", CompareMethod.Text)
            If intPosition2>0 Then
                goto xit
                blnHasIteratorSymbols = True
            End If
        End If
        intPosition = InStr(strC, "=")
        If intPosition>0 Then
            blnIsAssignmentStatement = True
        End If
     xit:
        Exit Sub
    End Sub

    Public Function intFindOperator(ByVal strX As String) As Short
        Dim intPos As Short
        Dim intLoupe As Short
        Dim strOp As String = ""

        For intLoupe = 1 To intOperatorCount
            strOp = straryOperators(intLoupe)
            intPos = InStr(strC, strOp)
            If intPos>0 Then
                intOperatorPosition = intPos
                intOperatorLength = Len(strOp)
                goto xit
            End If
        Next intLoupe
        intPos = 0
     xit:
        intFindOperator = intPos
        Exit Function
    End Function
    Public Sub FindNextVariable(ByRef strX As String, ByRef strNexVar As String)
        Dim intLen As Short
        Dim intLoo As Short
        Dim str1char As String = ""
        Dim str1charb4 As String = ""
        Dim blnStartedAVariable As Boolean
        Dim intStar As Short
        Dim intEn As Short
        Dim blnResetVarSearch As Boolean
        Dim strOrignal As String = ""
        Dim intIdx As Short

        strOrignal = strX
        blnStartedAVariable = False
        strNexVar = ""
        intLen = Len(strX)
        If intLen<1 Then
            goto xit
        End If
        str1charb4 = ";"
        intStar = 0
        intEn = 0
        For intLoo = 1 To intLen
            str1char = Mid(strX, intLoo, 1)
            If str1char=":" Then
                goto nullxit
            End If
            If str1char="." Then
                goto nullxit
            End If
            If str1char=strQ Then
                goto nullxit
            End If
            If str1char=strQQ Then
                goto nullxit
            End If
            If str1char="[" Then
                goto nullxit
            End If
            If str1char="]" Then
                goto nullxit
            End If
            If str1char="~" Then
                goto nullxit
            End If
            If blnIsVarChar(str1char) Then
                If  Not blnStartedAVariable Then
                    blnStartedAVariable = True
                    intStar = intLoo
                End If
            Else
                If blnStartedAVariable Then
                    intEn = intLoo-1
                    blnResetVarSearch = False
                    If  Not blnResetVarSearch Then
                        strNexVar = Mid(strX, intStar, intEn-intStar+1)
                        FindInMethListbox(strNexVar, intIdx)
                        If intIdx=-1 Then
                            strX = Mid(strX, intEn+1)
                            goto xit
                        Else
                            goto nullxit
                        End If
                    Else
                        goto nullxit
                    End If
                End If
            End If
            str1charb4 = str1char
        Next intLoo
        If intStar>0 Then
            If intEn=0 Then
                strNexVar = Mid(strX, intStar)
                strX = ""
            End If
        End If
        If intStar<1 Then
            strX = ""
            strNexVar = ""
        End If
     xit:
        intLocVarStartsAtChar = intStar
        If blnResetVarSearch Then
            intLocVarStartsAtChar = 0
            strNexVar = ""
        End If
        strNexVar = strRemoveLeading(strNexVar, "[")
        strNexVar = strRemoveLeading(strNexVar, "]")
        strNexVar = strRemoveLeading(strNexVar, ",")
        strNexVar = strRemoveTrailing(strNexVar, "[")
        strNexVar = strRemoveTrailing(strNexVar, ",")
     xit2:
        Exit Sub
     nullxit:
        strX = ""
        strNexVar = ""
        Exit Sub
    End Sub

    Public Function blnIsVarChar(ByVal strChar As String) As Boolean
        Dim intLenB As Short

        blnIsVarChar = False
        intLenB = Len(strChar)
        If intLenB=0 Then
            Exit Function
        End If
        If strChar>="a" Then
            If strChar<="z" Then
                blnIsVarChar = True
                Exit Function
            End If
        End If
        If strChar>="A" Then
            If strChar<="Z" Then
                blnIsVarChar = True
                Exit Function
            End If
        End If
        If strChar=" " Then
            Exit Function
        End If
        If strChar="_" Then
            blnIsVarChar = True
            Exit Function
        End If
        If strChar="." Then
            blnIsVarChar = False
            Exit Function
        End If
        If strChar="@" Then
            blnIsVarChar = True
            Exit Function
        End If
        If strChar="$" Then
            blnIsVarChar = True
            Exit Function
        End If
        If strChar="[" Then
            blnIsVarChar = False
            Exit Function
        End If
        If strChar="," Then
            blnIsVarChar = False
            Exit Function
        End If
        If strChar="]" Then
            blnIsVarChar = False
            Exit Function
        End If
        If strChar<"0" Then
            Exit Function
        End If
        If strChar>"9" Then
            If strChar<"A" Then
                Exit Function
            End If
        End If
        If strChar>"Z" Then
            If strChar<"a" Then
                Exit Function
            End If
        End If
        If strChar>"z" Then
            Exit Function
        End If
        blnIsVarChar = True
        Exit Function
    End Function

    Public Sub GetEndOfElement(ByVal strX As String)
        Dim intS As Short
        Dim strS As String = ""
        Dim intLenB As Short
        Dim strChar As String = ""
        Dim blnTF As Boolean

        intEndOfElement = 999
        intLenB = Len(strX)
        If intLenB=0 Then
            Exit Sub
        End If
        For intS = 1 To intLenB
            strChar = Mid(strX, intS, 1)
            blnTF = blnIsVarChar(strChar)
            If blnTF=False Then
                intEndOfElement = intS-1
                Exit Sub
            End If
        Next intS
    End Sub

    Public Function strRemoveQuotesFrom(ByVal strW As String, ByVal blnMustHavePairs As Boolean) As String
        strRemoveQuotesFrom = ""
        Dim intCount As Short
        Dim strSpaces As String = ""
        Dim intSanityCheck As Short
        Dim blnchanged As Boolean
        Dim strOrig As String = ""
        Dim strq_QQ_q As String = ""
        Dim strQQ_q_QQ As String = ""
        Dim strX As String = ""
        Dim strXB4 As String = ""
        Dim blnAllow As Boolean

        strX = strW
        strOrig = strX
        intSanityCheck = 0
        intErrCode = 0
        While 1 = 1
            intSanityCheck += 1
            If intSanityCheck > 30000 Then
                MsgBox("ENDLESS LOOP 8", MsgBoxStyle.Critical, strAppTitle)
                mStop()
            End If
            blnchanged = False
            intPosition = InStr(strX, strQQ)
            blnAllow = True 'handle \"
            If intPosition > 1 Then
                If Mid(strX, intPosition - 1, 1) = "\" Then
                    blnAllow = False
                End If
            End If
            strXB4 = strX
            strq_QQ_q = strQ & strQQ & strQ 'handle '"'
            strX = Replace(strX, strq_QQ_q, "qQq")
            If strX <> strXB4 Then
                While strX <> strXB4
                    strXB4 = strX
                    strX = Replace(strX, strq_QQ_q, "qQq")
                End While
            End If
            strQQ_q_QQ = strQQ & strQ & strQQ 'handle "'"
            strX = Replace(strX, strQQ_q_QQ, "QqQ")
            If strX <> strXB4 Then
                While strX <> strXB4
                    strXB4 = strX
                    strX = Replace(strX, strQQ_q_QQ, "QqQ")
                End While
            End If
            intPosition = InStr(strX, strQQ) 'substitute for " pairs
            If (intPosition > 0) And (blnAllow) Then
                Mid(strX, intPosition, 1) = "Q"
                intPosition2 = InStr(strX, strQQ)
                If intPosition2 > 0 Then
                    Mid(strX, intPosition2, 1) = "Q"
                    strLeft = VB.Left(strX, intPosition)
                    strRight = Mid(strX, intPosition2)
                    intCount = intPosition2 - intPosition - 1
                    strSpaces = Replicate(" ", intCount)
                    strX = strLeft & strSpaces & strRight
                    blnchanged = True
                Else
                    If blnMustHavePairs Then
                        MsgBox("Unbalanced doublequote character in " & strOrig, MsgBoxStyle.Critical, strAppTitle)
                        intErrCode = 5
                        GoTo xit
                    End If
                End If
            End If
            intPosition = InStr(strX, strQ)
            blnAllow = True
            If intPosition > 1 Then 'handle \'
                If Mid(strX, intPosition - 1, 1) = "\" Then
                    blnAllow = False
                End If
            End If
            If (intPosition > 0) And (blnAllow) Then
                Mid(strX, intPosition, 1) = "q" 'substitute for ' pairs
                intPosition2 = InStr(strX, strQ)
                If intPosition2 > 0 Then
                    Mid(strX, intPosition2, 1) = "q"
                    strLeft = VB.Left(strX, intPosition)
                    strRight = Mid(strX, intPosition2)
                    intCount = intPosition2 - intPosition - 1
                    strSpaces = Replicate(" ", intCount)
                    strX = strLeft & strSpaces & strRight
                    blnchanged = True
                Else
                    If blnMustHavePairs Then
                        MsgBox("Unbalanced singlequote character in " & strOrig, MsgBoxStyle.Critical, strAppTitle)
                        intErrCode = 5
                        GoTo xit
                    End If
                End If
            End If
            If Not blnchanged Then 'return with good string if no more changes
                strRemoveQuotesFrom = strX
                GoTo xit
            End If
        End While
xit:
        Exit Function
    End Function

    Public Function Replicate(ByVal s As String, ByVal n As Short) As String
        Replicate = ""
        Dim intLoopR As Short
        Dim strWork As String = ""

        strWork = ""
        For intLoopR = 1 To n
            strWork = strWork & s
        Next intLoopR
        Replicate = strWork
        Exit Function
    End Function

    Public Sub RemoveInlineCommentFrom(ByRef strToFix As String)
        Dim intS As Short
        Dim strX As String = ""
        Dim strY As String = ""
        Dim blnGo As Boolean

        strX = strToFix
        intS = InStr(strX, "#")
        If intS>0 Then
            blnGo = True
            While blnGo
                If Mid(strX, intS, 2)="#{" Then '#brace?
                    Mid(strX, intS, 1) = "~"
                Else
                    blnGo = False
                End If
                intS = InStr(strX, "#")
                If intS=0 Then
                    blnGo = False
                End If
            End While
        End If
        intS = InStr(strX, "#")
        If intS>0 Then
            blnGo = True
            While blnGo
                If Mid(strX, intS, 2)="#(" Then '#left parenthesis?
                    Mid(strX, intS, 1) = "~"
                Else
                    blnGo = False
                End If
                intS = InStr(strX, "#")
                If intS=0 Then
                    blnGo = False
                End If
            End While
        End If
        strY = strRemoveQuotesFrom(strX, False)
        If intErrCode = 5 Then
            GoTo xit
        End If
        intS = InStr(strY, "#")
        If intS>0 Then
            If Mid(intS, 7) <> strPrintDebugMethod Then
                strToFix = Trim(VB.Left(strX, intS - 1))
            End If
        End If
xit:
        Exit Sub
    End Sub

    Public Sub ReadFileIntoMemory(ByVal strReadFileName As String)
        Dim blnIsdbfrMyPrint As Boolean
        Dim blnContinued As Boolean
        Dim strAA As String = ""
        Dim strB As String = ""

        lngDebugLinesInSourceFile = 0
        On Error GoTo badxit
            FileOpen(1, strReadFileName, OpenMode.Input)
            On Error GoTo 0
            blnContinued = False
            strHere = ""
            lngSourcefileLinecount = 0
            While  Not EOF(1)
                If blnContinued Then
                    strAA = Trim(strNextLine)
                    If strAA="" Then
                        blnContinued = False
                        strAA = LineInput(1)
                        lngSourcefileLinecountMyPrint += 1
                    End If
                Else
                    strAA = LineInput(1)
                End If
                '
                '   Multiple statements on one line?
                '
            '                intPosition = InStr(strAA, ";")
            '               If intPosition>0 Then
            'strNextLine = Mid(strAA, intPosition + 1)
            'strAA = VB.Left(strAA, intPosition - 1)
            'blnContinued = True
            '    End If
            '
            '   Continuation lines?
            '
            '  strB = ""
            ' While blnIsLineContinued(strAA)
            'strB = strB & strAA
            'strAA = LineInput(1)
            'lngSourcefileLinecountMyPrint += 1
            'End While
            'If strB <> "" Then
            'strAA = strB & strAA
            'End If
            '
            '   otherwise normal...
            '
            straryOriginalLines(lngSourcefileLinecount + 1) = strAA
            straryLines(lngSourcefileLinecount + 1) = strAA
            lngSourcefileLinecount += 1
            If lngSourcefileLinecount = lngLineCountLimit Then
                MsgBox("More than " + Str(lngLineCountLimit) & " lines in " & strReadFileName, MsgBoxStyle.Critical, "ERROR")
                GoTo badxit
            End If
            If InStr(strAA, strPrintDebugMethod) Then
                If VB.Left(Trim(strAA), 4) <> "def " Then
                    lngDebugLinesInSourceFile += 1
                End If
            End If
        End While
xit:
        FileClose(1)
        Exit Sub
badxit:
        FileClose(1)
        MsgBox("ERROR-FILE NOT FOUND=" & strReadFileName)
        mStop()
    End Sub

    Public Function blnIsLineContinued(ByVal strX As String) As Boolean
        Dim strY As String = ""

        blnIsLineContinued = False
        strY = Trim(strX)
        If Len(strY)<2 Then
            goto xit
        End If
        If VB.Right(strY, 1)="+" Then
            goto goodxit
        End If
        If VB.Right(strY, 1)="/" Then
            goto goodxit
        End If
        If VB.Right(strY, 1)="\" Then
            goto goodxit
        End If
        If VB.Right(strY, 1)="-" Then
            goto goodxit
        End If
     xit:
        Exit Function
     goodxit:
        blnIsLineContinued = False
        goto xit
    End Function

    Public Function strRemoveLeading(ByVal strB As String, ByVal strCh As String) As String
        strRemoveLeading = ""
        Dim strBB As String = ""
        Dim strL As String = ""

        strBB = strB
        If Len(strB)=0 Then
            goto xit
        End If
        If Len(strCh)<>1 Then
            goto xit
        End If
        strL = VB.Left(strBB, 1)
        While strL=strCh
            If Len(strBB)>1 Then
                strBB = Mid(strBB, 2)
                strL = VB.Left(strBB, 1)
            Else
                strBB = ""
                goto xit
            End If
        End While
     xit:
        strRemoveLeading = strBB
        Exit Function
    End Function
    Public Function strRemoveTrailing(ByVal strB As String, ByVal strCh As String) As String
        strRemoveTrailing = ""
        Dim intL As Short
        Dim strBB As String = ""
        Dim strR As String = ""

        strBB = strB
        If Len(strB)=0 Then
            goto xit
        End If
        strR = VB.Right(strBB, 1)
        If Len(strCh)<>1 Then
            goto xit
        End If
        While strR=strCh
            If Len(strBB)>1 Then
                intL = Len(strBB)-1
                strBB = VB.Left(strBB, intL)
                strR = VB.Right(strBB, 1)
            Else
                strBB = ""
                goto xit
            End If
        End While
     xit:
        strRemoveTrailing = strBB
        Exit Function
    End Function
    Public Function LeftOfCharacter(ByVal StringToStrip As String, ByVal Character As String, Optional ByVal ReverseDirection As Boolean = False) As String
        LeftOfCharacter = ""
        ' reverse direction starts at the end of the string and returns everything to the
        ' left of the first character it encounters, which will be the last instance of that
        ' character in the string
        ' character can only be one letter long

        If Len(Character)>1 Then
            goto Err_Too_Long
        End If
        ' If Len(Character) > 1 Then Err.Raise 6 ' system error code 6
        ' The handle is invalid.
        ' ERROR_INVALID_HANDLE
        ' why this one?

        Dim i As Short


        '  If IsMissing(ReverseDirection) Then
        If  Not ReverseDirection Then
            i = InStr(StringToStrip, Character)

            If i<>0 Then
                LeftOfCharacter = VB.Left(StringToStrip, i-1)
                goto xit
            Else
                '   LeftOfCharacter = ""  'why not this?
            End If
        Else
            For i = Len(StringToStrip) To 1 Step -1
                If Mid(StringToStrip, i, 1)=Character Then
                    LeftOfCharacter = Mid(StringToStrip, 1, i-1)
                    goto xit
                End If
            Next i
            ' LeftOfCharacter = ""  'why not this?
        End If
        LeftOfCharacter = StringToStrip
     xit:
        Exit Function
     Err_Too_Long:
        MsgBox("Programming error-searchfor string too long in LeftOfCharacter routines", MsgBoxStyle.Critical, "ERROR")
        LeftOfCharacter = StringToStrip
        goto xit
    End Function
    Public Function blnHasLeadingNumber(ByVal strToCheck As String) As Boolean
        Dim intL As Short
        Dim intLuup As Short
        Dim str1ch As String = ""
        Dim intDots As Short

        intL = Len(strToCheck)
        If intL=0 Then
            goto xitfalse
        End If
        intDots = 0
        For intLuup = 1 To intL
            str1ch = Mid(strToCheck, intLuup, 1)
            If str1ch>"9" Then
                goto xitfalse
            End If
            If str1ch>="0" Then
                goto xittrue
            End If
            If str1ch="." Then
                intDots += 1
            End If
        Next intLuup
        If intDots>1 Then
            goto xitfalse
        End If
     xittrue:
        blnHasLeadingNumber = True
        Exit Function
     xitfalse:
        blnHasLeadingNumber = False
        Exit Function
    End Function
    Public Function RightOfCharacter(ByVal StringToStrip As String, ByVal Character As String, Optional ByVal ReverseDirection As Boolean = False) As String
        RightOfCharacter = ""
        Dim i As Short

     again:
        If Len(Character)>1 Then
            goto Err_Too_Long
        End If
        i = InStr(StringToStrip, Character)

        If i=0 Then
            RightOfCharacter = ""
            goto xit
        Else
            RightOfCharacter = VB.Right(StringToStrip, Len(StringToStrip)-i)
        End If
        If ReverseDirection Then
            i = InStr(RightOfCharacter, Character)
            If i>0 Then
                goto again
            End If
        End If
     xit:
        Exit Function
     Err_Too_Long:
        MsgBox("Programming error-searchfor string too long in RightOfCharacter routines", MsgBoxStyle.Critical, strAppTitle)
        RightOfCharacter = StringToStrip
        goto xit
    End Function

    Public Function strRemoveLastOccurenceOf(ByVal StringToStrip As String, ByVal Character As String) As String
        strRemoveLastOccurenceOf = ""
        Dim i As Short
        Dim ib4 As Short
        Dim strX As String = ""
        Dim intLen As Short


        strRemoveLastOccurenceOf = StringToStrip
        intLen = Len(Character)
        If intLen<=0 Then
            goto xit
        End If
        strX = StringToStrip
        If strX="" Then
            goto xit
        End If
        ib4 = 0
        i = InStr(1, StringToStrip, Character, CompareMethod.Text) 'can't instr do a backwards search?
        While i>0
            strX = Mid(strX, i+1)
            ib4 = i
            i = InStr(i, strX, Character, CompareMethod.Text)
        End While
        If ib4=0 Then
            goto xit
        End If
        strX = VB.Left(StringToStrip, ib4-1)+Mid(StringToStrip, ib4+intLen)
        strRemoveLastOccurenceOf = strX
     xit:
        Exit Function
    End Function

    Public Sub ShowHourglass()
        'DisplayArea.Cursor = Cursors.Wait
        'vbHourGlass
        'vbArrow
        'DisplayArea.Cursor = Cursors.Arrow
        '        Mouse.OverrideCursor = Cursors.Wait
        '     Me.Cursor = Cursors.WaitCursor
        Cursor.Current = Cursors.WaitCursor

    End Sub

    Public Sub ShowNormalPointer()
        'Me.Cursor = Cursors.Default
        'Mouse.OverrideCursor = Cursors.Default
        Cursor.Current = Cursors.Default
    End Sub


    Public Function blnIsUppercase(ByVal strX As String) As Boolean

        If strX>"A" Then
            If strX<="Z" Then
                blnIsUppercase = True
                goto xit
            End If
        End If
        blnIsUppercase = False
     xit:
        Exit Function
    End Function

    Public Sub FindInMethListbox(ByVal strLookFor As String, ByRef intIdx As Short)
        Dim intMax As Short
        Dim strVName As String = ""
        Dim intLoop2 As Short
        Dim strHave As String = ""
        Dim strClass As String = ""

        intMax = frmDebuggifierLists.lstMethods.Items.Count
        For intLoop2 = 1 To intMax
            strHave = frmDebuggifierLists.lstMethods.Items.Item(intLoop2-1).ToString()
            strClass = LeftOfCharacter(strHave, "/")
            strHave = RightOfCharacter(strHave, "/")
            strHave = Mid(strHave, 5)
            If strHave=strLookFor Then
                If Len(strHave)=Len(strLookFor) Then
                    If strClass=strClassDec Then
                        intIdx = intLoop2-1
                        Exit Sub
                    End If
                End If
            End If
        Next intLoop2

        intIdx = -1
    End Sub
    Public Sub mStop()
        End
    End Sub
    Public Function PathExtract(ByVal thePath As String) As String
        Dim tempstring As String

        tempstring = LeftOfCharacter(thePath, "\", True)

        If tempstring = thePath Then
            PathExtract = thePath
        Else
            PathExtract = Left(thePath, Len(tempstring) + 1)
        End If
    End Function

End Module